#ifndef EFL_UI_DND_EO_HH
#define EFL_UI_DND_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_ui_dnd.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#ifndef EFL_UI_DND_FWD_GUARD
#define EFL_UI_DND_FWD_GUARD
namespace efl { namespace ui { 
struct Dnd;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Dnd> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Dnd&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Dnd const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Dnd const&> : ::std::true_type {}; } }
#endif

namespace eo_cxx {
namespace efl { namespace ui { 
struct Dnd {
template <typename F>    ::efl::eolian::return_traits<void>::type drag_start( ::efl::eolian::in_traits<Efl_Selection_Format>::type format,  ::efl::eolian::in_traits<Eina_Slice>::type data,  ::efl::eolian::in_traits<Efl_Selection_Action>::type action, F icon_func,  ::efl::eolian::in_traits< unsigned int>::type seat) const;
   ::efl::eolian::return_traits<void>::type drag_action_set( ::efl::eolian::in_traits<Efl_Selection_Action>::type action,  ::efl::eolian::in_traits< unsigned int>::type seat) const;
   ::efl::eolian::return_traits<void>::type drag_cancel( ::efl::eolian::in_traits< unsigned int>::type seat) const;
   ::efl::eolian::return_traits<void>::type drop_target_add( ::efl::eolian::in_traits<Efl_Selection_Format>::type format,  ::efl::eolian::in_traits< unsigned int>::type seat) const;
   ::efl::eolian::return_traits<void>::type drop_target_del( ::efl::eolian::in_traits<Efl_Selection_Format>::type format,  ::efl::eolian::in_traits< unsigned int>::type seat) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_DND_MIXIN;
   }
   Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Dnd *>(this))); }
   operator ::efl::ui::Dnd() const;
   operator ::efl::ui::Dnd&();
   operator ::efl::ui::Dnd const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Dnd> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Dnd const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace ui { 
struct Dnd : private ::efl::eo::concrete
{
   explicit Dnd( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   Dnd(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   explicit Dnd() = default;
   Dnd(Dnd const&) = default;
   Dnd(Dnd&&) = default;
   Dnd& operator=(Dnd const&) = default;
   Dnd& operator=(Dnd&&) = default;
   template <typename Derived>
   Dnd(Derived&& derived
      , typename std::enable_if<
         ::efl::eo::is_eolian_object<Derived>::value
          && std::is_base_of< Dnd, Derived>::value>::type* = 0)
         : ::efl::eo::concrete(derived._eo_ptr()) {}

template <typename F>    ::efl::eolian::return_traits<void>::type drag_start( ::efl::eolian::in_traits<Efl_Selection_Format>::type format,  ::efl::eolian::in_traits<Eina_Slice>::type data,  ::efl::eolian::in_traits<Efl_Selection_Action>::type action, F icon_func,  ::efl::eolian::in_traits< unsigned int>::type seat) const;
   ::efl::eolian::return_traits<void>::type drag_action_set( ::efl::eolian::in_traits<Efl_Selection_Action>::type action,  ::efl::eolian::in_traits< unsigned int>::type seat) const;
   ::efl::eolian::return_traits<void>::type drag_cancel( ::efl::eolian::in_traits< unsigned int>::type seat) const;
   ::efl::eolian::return_traits<void>::type drop_target_add( ::efl::eolian::in_traits<Efl_Selection_Format>::type format,  ::efl::eolian::in_traits< unsigned int>::type seat) const;
   ::efl::eolian::return_traits<void>::type drop_target_del( ::efl::eolian::in_traits<Efl_Selection_Format>::type format,  ::efl::eolian::in_traits< unsigned int>::type seat) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_DND_MIXIN;
   }
   Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Dnd *>(this))); }
   static struct drag_accept_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_DND_EVENT_DRAG_ACCEPT; }
      typedef bool const& parameter_type;
   } const drag_accept_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_accept_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_accept_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_accept_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_accept_event, *this, std::bind(function));
   }
#endif
   static struct drag_done_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_DND_EVENT_DRAG_DONE; }
      typedef void parameter_type;
   } const drag_done_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_done_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_done_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_done_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_done_event, *this, std::bind(function));
   }
#endif
   static struct drag_enter_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_DND_EVENT_DRAG_ENTER; }
      typedef void parameter_type;
   } const drag_enter_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_enter_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_enter_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_enter_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_enter_event, *this, std::bind(function));
   }
#endif
   static struct drag_leave_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_DND_EVENT_DRAG_LEAVE; }
      typedef void parameter_type;
   } const drag_leave_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_leave_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_leave_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_leave_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_leave_event, *this, std::bind(function));
   }
#endif
   static struct drag_pos_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_DND_EVENT_DRAG_POS; }
      typedef Efl_Dnd_Drag_Pos parameter_type;
   } const drag_pos_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_pos_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_pos_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_pos_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_pos_event, *this, std::bind(function));
   }
#endif
   static struct drag_drop_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_DND_EVENT_DRAG_DROP; }
      typedef Efl_Selection_Data parameter_type;
   } const drag_drop_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_drop_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_drop_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_drop_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_drop_event, *this, std::bind(function));
   }
#endif
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Dnd> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Dnd const > operator&() const { return {this}; }
   /// @endcond
   ::efl::eo::wref<Dnd> _get_wref() const { return ::efl::eo::wref<Dnd>(*this); }
   ::efl::eo::concrete const& _get_concrete() const { return *this; }
   ::efl::eo::concrete& _get_concrete() { return *this; }
   using ::efl::eo::concrete::_eo_ptr;
   using ::efl::eo::concrete::_release;
   using ::efl::eo::concrete::_reset;
   using ::efl::eo::concrete::_delete;
   using ::efl::eo::concrete::operator bool;
#ifdef EFL_CXXPERIMENTAL
   const Dnd* operator->() const { return this; }
   Dnd* operator->() { return this; }
   operator Eo*() const { return _eo_ptr(); }
#endif 
   friend bool operator==(Dnd const& lhs, Dnd const& rhs)
   { return lhs._get_concrete() == rhs._get_concrete(); }
   friend bool operator!=(Dnd const& lhs, Dnd const& rhs)
   { return !(lhs == rhs); }
};
static_assert(sizeof(Dnd) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Dnd>::value, "");
} } 
#endif
